package spring.aop.simulation;

import java.util.ArrayList;
import java.util.List;

import spring.aop.simulation.proxy.AopProxy;
import spring.aop.simulation.proxy.JdkDynamicAopProxy;
import spring.aop.simulation.proxy.advice.Interceptor;
import spring.aop.simulation.proxy.advice.interceptor.MethodBeforeAdviceInterceptor;
import spring.aop.simulation.proxy.advice.interceptor.MethodReturningAdviceInterceptor;
import spring.aop.simulation.proxy.advice.interceptor.MethodThrowingAdviceInterceptor;
import spring.aop.simulation.service.Child;
import spring.aop.simulation.service.Person;

public class App {
    public static void main(String[] args) {
    	List<Interceptor> interceptorList = new ArrayList<>();
    	interceptorList.add(new MethodBeforeAdviceInterceptor());
    	interceptorList.add(new MethodReturningAdviceInterceptor());
    	interceptorList.add(new MethodThrowingAdviceInterceptor());
    	
        AopProxy aopProxy = new JdkDynamicAopProxy(new Child(), interceptorList);
        Person childProxy = (Person) aopProxy.getProxy();
        childProxy.play("video game");
//        childProxy.play(null);
    }
}